### Method

# Gio DataInputStream read_line_utf8

since: 2.30

#### Declaration [src]

    char*
    g_data_input_stream_read_line_utf8 (
      GDataInputStream* stream,
      gsize* length,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Reads a UTF-8 encoded line from the data input stream.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

Available since: 2.30

#### Parameters

`length`

  Type: `gsize*`

  A #gsize to get the length of the data read in.

  The argument will be set by the function.
  The argument can be `NULL`.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `char*`

A NUL terminated UTF-8 string with the line that was read in (without the newlines). Set `length` to a #gsize to get the length of the read line. On an error, it will return `NULL` and `error` will be set. For UTF-8 conversion errors, the set error domain is `G_CONVERT_ERROR`. If there’s no content to read, it will still return `NULL`, but `error` won’t be set.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The return value can be `NULL`.
The value is a NUL terminated UTF-8 string.